clear all, close all 

!ctraceo scenario_erf30m 

disp('Reading the output data...')

load eig

figure, hold on

[a, b] = size(eigenrays);   %get dimensions of hydrophone array

for rHyd = 1:a  %iterate over hydrophone ranges
    for zHyd = 1:b  %iterate over hydrophone depths
        for i = 1:eigenrays(a,b).nEigenrays   %iterate over eigenrays of hydrophone
            plot(eigenrays(a,b).eigenray(i).r, eigenrays(a,b).eigenray(i).z)
	    lz = length( eigenrays(a,b).eigenray(i).z );
	    tau(i) = eigenrays(a,b).eigenray(i).tau(lz);
	    amp(i) = eigenrays(a,b).eigenray(i).amp(lz);
        end
    end
end

grid on, box on
view(0,-90)
hold off 
xlabel('Range (m)')
ylabel('Depth (m)')
title('cTRACEO - UAN simulator, eigenrays')

figure(2) 
stem(tau,abs(amp))
box on, grid on

disp('done.')
